'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

const INFERED_PROPERTY_MAP = new Map([['array', ['additionalItems', 'items', 'maxItems', 'minItems', 'uniqueItems']], ['string', ['maxLength', 'minLength', 'pattern']], ['number', ['exclusiveMaximum', 'exclusiveMinimum', 'maximum', 'minimum', 'multipleOf']], ['object', ['additionalProperties', 'dependencies', 'maxProperties', 'minProperties', 'patternProperties', 'properties', 'required']]]);

class Schema {
    constructor(id, rawSchema, schema, path, absPath) {
        this.id = id;
        this.rawSchema = rawSchema;
        this.schema = schema;
        this.path = path;
        this.absPath = absPath;
    }

    getPropertySchema(property) {
        return this.schema.properties[property];
    }

    isRequired(property) {
        let required = this.schema.required || [];
        return required.indexOf(property) !== -1;
    }

    getType(definition) {
        if (definition.type) {
            return definition.type;
        }

        for (let _ref of INFERED_PROPERTY_MAP) {
            var _ref2 = _slicedToArray(_ref, 2);

            let key = _ref2[0];
            let value = _ref2[1];

            let matched = Object.keys(definition).some(property => value.indexOf(property) !== -1);
            if (matched) {
                return key;
            }
        }

        return null;
    }
}
exports.Schema = Schema;