'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
const ENTITY_CONTAINER_KEY = Symbol('entityContainer');
const API_CONTAINER_KEY = Symbol('apiContainer');

class SchemaContainer {
    constructor() {
        this[ENTITY_CONTAINER_KEY] = new Map();
        this[API_CONTAINER_KEY] = new Map();
    }

    registerEntity(id, schema) {
        this[ENTITY_CONTAINER_KEY].set(id, schema);
    }

    setEntity(id, options) {
        this[ENTITY_CONTAINER_KEY].set(id, options);
    }

    getEntity(id) {
        return this[ENTITY_CONTAINER_KEY].get(id);
    }

    registerAPI(id, schema) {
        this[API_CONTAINER_KEY].set(id, { raw: schema });
    }

    setAPI(id, options) {
        this[API_CONTAINER_KEY].set(id, options);
    }

    getAPI(id) {
        return this[API_CONTAINER_KEY].get(id);
    }

    getEntities() {
        return this[ENTITY_CONTAINER_KEY];
    }

    getAPIS() {
        return this[API_CONTAINER_KEY];
    }
}

const container = exports.container = new SchemaContainer();