'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SchemaScanner = undefined;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _schemaResolver = require('./schema-resolver');

var _Schema = require('./Schema');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class SchemaScanner {
    scan(schemaDir) {
        let files = _fs2.default.readdirSync(schemaDir);
        return files.reduce((prev, cur) => {
            let filePath = _path2.default.join(schemaDir, cur);
            if (_fs2.default.lstatSync(filePath).isFile() && /\.json$/.test(cur)) {
                let schema = JSON.parse(_fs2.default.readFileSync(filePath));
                if (schema.id) {
                    prev.push(new _Schema.Schema(schema.id, schema, (0, _schemaResolver.resolver)(schema, { baseFolder: schemaDir }), filePath));
                }
            }
            return prev;
        }, []);
    }
}
exports.SchemaScanner = SchemaScanner;