'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.create = create;

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _serverDestroy = require('server-destroy');

var _serverDestroy2 = _interopRequireDefault(_serverDestroy);

var _methodOverride = require('method-override');

var _methodOverride2 = _interopRequireDefault(_methodOverride);

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _router = require('./router');

var routerIndex = _interopRequireWildcard(_router);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function create(db) {
    let config = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    let app = (0, _express2.default)();
    app.set('json spaces', 2);

    app.use(_bodyParser2.default.urlencoded({ extended: false }));
    app.use(_bodyParser2.default.json({ limit: '10mb' }));
    app.use((0, _methodOverride2.default)());

    let router = routerIndex.router(db, config);

    let defaultsOpts = {
        logger: !config.quiet
    };

    if (config.routes) {
        config.routes.forEach(_ref => {
            let method = _ref.method;
            let url = _ref.url;
            let handler = _ref.handler;
            return app[method.toLowerCase()](url, _lodash2.default.partial(handler, db));
        });
    }

    if (config.urlPrefix) {
        app.use(config.urlPrefix, router);
    }

    app.db = db;
    app.use(router);

    return app;
}