'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.plural = plural;

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _pluralHandlers = require('./plural-handlers');

var pluralHandlers = _interopRequireWildcard(_pluralHandlers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function plural(db, name) {
    let overrides = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    let router = _express2.default.Router();

    let list = _lodash2.default.partial(pluralHandlers.list || overrides.list, db, name);
    let get = _lodash2.default.partial(pluralHandlers.get || overrides.get, db, name);
    let update = _lodash2.default.partial(pluralHandlers.update || overrides.update, db, name);
    let create = _lodash2.default.partial(pluralHandlers.create || overrides.create, db, name);
    let remove = _lodash2.default.partial(pluralHandlers.remove || overrides.remove, db, name);

    router.route('/').get(list).post(create);

    router.route('/:id').get(get).put(update).patch(update).delete(remove);

    return router;
}