'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.singular = singular;

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _singularHandlers = require('./singular-handlers');

var singularHandlers = _interopRequireWildcard(_singularHandlers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function singular(db, name, overrides) {
    let router = _express2.default.Router();

    let get = _lodash2.default.partial(singularHandlers.get || overrides.get, db, name);
    let update = _lodash2.default.partial(singularHandlers.update || overrides.update, db, name);
    let create = _lodash2.default.partial(singularHandlers.create || overrides.create, db, name);

    router.route('/').get(get).post(create).put(update).patch(update);

    return router;
}